代码改变世界

LeetCode(2) || Add Two Numbers && Longest Substring Without Repeating Characters

2015-03-05 22:16  追风的蓝宝  阅读(394)  评论(0编辑  收藏  举报

LeetCode(2) || Add Two Numbers && Longest Substring Without Repeating Characters

题记

刷LeetCode第二天,今天做了两道题,速度比我想的要慢,看样子两个月的目标有点难,尽力吧。今天主要做了Add Two Numbers和Longest Substring Without Repeating Characters 两道题,下面就来看下这两道题吧。

题一:Add Two Numbers 

题目内容

You are given two linked lists representing two non-negative numbers. The digits are stored in reverse order and each of their nodes contain a single digit. Add the two numbers and return it as a linked list.

Input: (2 -> 4 -> 3) + (5 -> 6 -> 4)
Output: 7 -> 0 -> 8

解题思路

  • LeetCode给的函数。
 1 /**
 2  * Definition for singly-linked list.
 3  * public class ListNode {
 4  *     int val;
 5  *     ListNode next;
 6  *     ListNode(int x) {
 7  *         val = x;
 8  *         next = null;
 9  *     }
10  * }
11  */
12 public class Solution {
13     public ListNode addTwoNumbers(ListNode l1, ListNode l2) {
14         
15     }
16 }
  • 题目的意思大致是:给出两个链表,这两个链表其实表示的一个倒置的非负整数,每一个节点表示非负整数的某一位上的数。比如链表2 -> 4 -> 3,其实表示的整数342。那么现在要做的是就是有这样的两个整数相加,最后返回同样规则的链表.比如 2->4->3 + 5 -> 6 ->4 = 7 -> 0 -> 8 即 342+465 = 807.
  • 这道题难度不是很大,我能想到有两种思路,第一种将每一个链表转换成十进制整数,然后整数相加,再将相加后的整数转换成链表输出,计算复杂度在2*O(n),而另一种就是直接链表相加,处理好进位就OK了,计算复杂度在O(n)。说实话,本来我以为第二种的运算时间是要小于第一种的,但是没想到结果差不多。其实当时我还想了另外一种方法,就是在进行链表转换成十进制整数以及十进制整数转换成链表时候,用16进制代替,这样就可以用移位代替除法操作,但是奈何16进制的加法一时没辙。

解题结果

方法一:

 1  public ListNode addTwoNumbers(ListNode l1, ListNode l2) {
 2         long num1 = 0;
 3         long num2 = 0;
 4         ListNode pl1 = l1;
 5         ListNode pl2 = l2;
 6         long index1 = 1;
 7         long index2 = 1;
 8         if ( l1 == null || l2 == null ){
 9             return null;
10         }
11         
12         while(true){
13             
14             if ( pl1 != null ){
15                 num1 += pl1.val*index1;
16                 pl1 = pl1.next;
17                 index1*=10;
18             }
19             
20             if ( pl2 != null ){
21                 num2 += pl2.val*index2;
22                 pl2 = pl2.next;
23                 index2*=10;
24             }
25             
26             if( pl2 == null && pl1 == null ){
27                 break;
28             }
29             
30         }
31         
32         long sum = num1 + num2;
33         
34         ListNode head = new ListNode((int) (sum % 10));
35         head.next = null;
36         sum = sum / 10;
37         ListNode lsPoint = head;
38         
39         while( sum > 0 ){
40             ListNode lnSum = new ListNode((int) (sum % 10));
41             lsPoint.next = lnSum;
42             sum = sum / 10;
43             lsPoint = lnSum;
44         }      
45         
46         return head;
47     }

方法二:

 1 public ListNode addTwoNumbers(ListNode l1, ListNode l2) {
 2         ListNode pl1 = l1;
 3         ListNode pl2 = l2;
 4         ListNode pHead = new ListNode(0);
 5         ListNode pTravel = pHead;
 6         int sum;
 7         int carry = 0;
 8         if ( l1 == null || l2 == null ){
 9             return null;
10         }
11         
12         while( pl1 != null || pl2 != null ){
13             int val1 = 0;
14             int val2 = 0;
15             if ( pl1 != null){
16                 val1 = pl1.val;
17                 pl1 = pl1.next;  
18             }
19             
20             if ( pl2 != null){
21                 val2 = pl2.val;
22                 pl2 = pl2.next;                
23             }
24             
25             sum = val1 + val2 + carry;             
26             ListNode newNode = new ListNode(sum % 10);
27             pTravel.next = newNode;
28             pTravel = newNode;
29             carry = sum / 10;
30 
31         }
32         
33         if( carry == 1 ){
34             ListNode newNode = new ListNode(carry);
35             pTravel.next = newNode;
36             pTravel = newNode;
37         }
38         return pHead.next;
39     }

两种方法的运行时间差不多,但是最短时间大概是在350ms,不知道是怎么弄出来的。

题二:Longest Substring Without Repeating Characters

题目内容

Given a string, find the length of the longest substring without repeating characters. For example, the longest substring without repeating letters for "abcabcbb" is "abc", which the length is 3. For "bbbbb" the longest substring is "b", with the length of 1.

解题思路

  • LeetCode给出的函数
1 public class Solution {
2     public int lengthOfLongestSubstring(String s) {
3         
4     }
5 }
  • 题目的意思大致是:找寻字符串S里面字符不重复的最长的子串长度。
  • 一般情况下,用两个for循环能获取最长的子串长度,计算复杂度是o(n2),想都不用想肯定通不过。因为O(n2)在遍历的时候会进行重复的遍历。

看一个例子:

S="abbdeca"。

t1="abbdeca",t1[1]==t1[2]。

t2="bbdeca",t2[0]==t2[1]。

t3="bdeca",一直扫描到最后。

t4="deca"、t5、t6、t7都同上。

我们在处理t1的时候已经扫描到了s[2],然后处理t3的时候扫描了s[2]到s[6],这两个子串已经扫描完了整个母串。

换言之,能使得子串停止扫描的位置只有两处:1.s[2];2.s[6](结尾)。

对于另一个例子S="aaab",能使子串停止扫描的位置分别是:s[1],s[2],s[3](结尾)。

  • 由此可见,之所以出现重复遍历,是因为在母串中扫描每一个字符都需要知道该字符是否在子串中出现过,如果使用遍历子串的方式那么肯定就费时了。那么有啥法子可以不遍历就知道重不重复呢,Hash表就可以实现,复杂度也变为了o(n)。同样我采用了两种方法,一种是使用Java自带的HashMap结构,另一种是自己定义数组来实现Hash。
  • 但是实际做的时候发现单单使用Hash还是不行的,需要有个指针来表示子串的起始的位置。比如字符串s="akicklac",当我扫描到第二个k,也就是s[4]是,Hash表里面存放的是a,k,i,c,s[4]已经替换了s[1]的那个k了,这是子串起始位置需要从s[0]变为s[2],否则s[6]会因为s[0]的存在而少算。

解题结果

方法一

 

 1     public int lengthOfLongestSubstring(String s) {
 2         Map<Character,Integer> hash = new HashMap<Character,Integer>();
 3         int num = 0;
 4         int max = 0;
 5         int start = 0;
 6         for(int i = 0 ; i < s.length() ; i++ ){
 7             Character cha = s.charAt(i);
 8             if( hash.containsKey(cha)){
 9                 int val = hash.get(cha);
10                 if ( val >= start) {
11                     start = val + 1;
12                     num = i - val - 1;
13                 }
14             }
15             hash.put(cha, i);
16             num++; 
17             max = max < num ? num : max;
18         }
19         return max;
20     }

 

 

方法二

 1     public int lengthOfLongestSubstring(String s) {
 2         int max = 0;
 3         int[] local = new int[256];
 4         int start = 0;
 5         int num = 0;
 6         for( int i = 0 ; i < s.length(); i++ ){
 7             Character ch = s.charAt(i);    
 8             int localValue = local[ch] ;
 9             if ( localValue-- > start ){
10                 start = localValue + 1;
11                 num = i - localValue - 1;
12             }
13             local[ch] =  i + 1;
14             num++; 
15             max = max < num ? num : max;
16         }
17         return max;
18     }